package it.polito.bigdata.hadoop;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.conf.Configured;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.DoubleWritable;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.NullWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.KeyValueTextInputFormat;
import org.apache.hadoop.mapreduce.lib.input.TextInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
import org.apache.hadoop.mapreduce.lib.output.TextOutputFormat;
import org.apache.hadoop.util.Tool;
import org.apache.hadoop.util.ToolRunner;

public class DriverBigData extends Configured implements Tool {
    @Override
    public int run(String[] args) throws Exception {
        int exitCode;
        Path inputPath;
        Path outputPath1;
        Path outputPath2;

        inputPath = new Path(args[0]);
        outputPath1 = new Path(args[1]);
        outputPath2 = new Path(args[2]);

        int nReducers = 2;

        Configuration conf = this.getConf();
        Job job = Job.getInstance(conf);
        job.setJobName("Exam20210917");

        FileInputFormat.addInputPath(job, inputPath);
        FileOutputFormat.setOutputPath(job, outputPath1);

        job.setJarByClass(DriverBigData.class);
        job.setMapperClass(MapperBigData1.class);
        job.setReducerClass(ReducerBigData1.class);

        job.setInputFormatClass(TextInputFormat.class);
        job.setOutputFormatClass(TextOutputFormat.class);

        job.setMapOutputKeyClass(Text.class);
        job.setMapOutputValueClass(Text.class);

        job.setOutputKeyClass(Text.class);
        job.setOutputValueClass(IntWritable.class);

        job.setNumReduceTasks(nReducers);

        if(job.waitForCompletion(true)) {
            Job job2 = Job.getInstance(conf);
            job2.setJobName("Exam step2");
            FileInputFormat.addInputPath(job2, outputPath1);
            FileOutputFormat.setOutputPath(job2, outputPath2);

            job2.setJarByClass(DriverBigData.class);

            job2.setInputFormatClass(KeyValueTextInputFormat.class);
            job2.setOutputFormatClass(TextOutputFormat.class);

            job2.setMapperClass(MapperBigData2.class);
            job2.setReducerClass(ReducerBigData2.class);

            job2.setMapOutputKeyClass(Text.class);
            job2.setMapOutputValueClass(IntWritable.class);

            job2.setOutputKeyClass(Text.class);
            job2.setOutputValueClass(NullWritable.class);

            job2.setNumReduceTasks(1);
            if(job2.waitForCompletion(true))
                exitCode = 0;
            else
                exitCode = 1;
        }
        else
            exitCode = 1;

        return exitCode;
    }

    public static void main(String[] args) throws Exception {
        int res = ToolRunner.run(new Configuration(), new DriverBigData(), args);

        System.exit(res);
    }
}
