package it.polito.bigdata.hadoop;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;

import java.io.IOException;

public class MapperBigData2 extends Mapper<Text, Text, Text, IntWritable> {
    private int maxCount;
    private String maxUser;

    @Override
    protected void setup(Mapper<Text, Text, Text, IntWritable>.Context context) throws IOException, InterruptedException {
        maxCount = -1;
        maxUser = null;
    }

    @Override
    protected void map(Text key, Text value, Mapper<Text, Text, Text, IntWritable>.Context context) throws IOException, InterruptedException {
        int count = Integer.parseInt(value.toString());

        if(count > maxCount || (count == maxCount && key.toString().compareTo(maxUser) < 0)) {
            maxCount = count;
            maxUser = key.toString();
        }
    }

    @Override
    protected void cleanup(Mapper<Text, Text, Text, IntWritable>.Context context) throws IOException, InterruptedException {
        if(maxUser != null)
            context.write(new Text(maxUser), new IntWritable(maxCount));
    }
}
