package it.polito.bigdata.hadoop;

import org.apache.hadoop.io.DoubleWritable;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;
import org.apache.hadoop.util.hash.Hash;

import java.io.IOException;
import java.util.HashMap;

public class ReducerBigData1 extends Reducer<Text, Text, Text, IntWritable> {
    private int maxCount2010;
    private String maxUser;

    @Override
    protected void setup(Reducer<Text, Text, Text, IntWritable>.Context context) throws IOException, InterruptedException {
        maxCount2010 = -1;
        maxUser = null;
    }

    @Override
    protected void reduce(Text key, Iterable<Text> values, Context context) throws IOException, InterruptedException {
        HashMap<Integer, Integer> yearCount = new HashMap<>();
        int oldValue = -1;

        for(Text val : values) {
            String[] fields = val.toString().split("_");
            int year = Integer.parseInt(fields[0]);
            int count = Integer.parseInt(fields[1]);

            if(yearCount.containsKey(year))
                oldValue = yearCount.get(year);
            else
                oldValue = 0;
            yearCount.put(year, oldValue + count);
        }

        if(yearCount.entrySet().size() == 1 && yearCount.containsKey(2010)) {
            int val = yearCount.get(2010);
            if(val > maxCount2010 || (val == maxCount2010 && key.toString().compareTo(maxUser) < 0)) {
                maxCount2010 = val;
                maxUser = key.toString();
            }
        }
    }

    @Override
    protected void cleanup(Reducer<Text, Text, Text, IntWritable>.Context context) throws IOException, InterruptedException {
        if(maxUser != null)
            context.write(new Text(maxUser), new IntWritable(maxCount2010));
    }
}
