package it.polito.bigdata.hadoop;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.NullWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

import java.io.IOException;

public class ReducerBigData2 extends Reducer<Text, IntWritable, Text, NullWritable> {
    private int maxCount;
    private String maxUser;

    @Override
    protected void setup(Reducer<Text, IntWritable, Text, NullWritable>.Context context) throws IOException, InterruptedException {
        maxCount = -1;
        maxUser = null;
    }

    @Override
    protected void reduce(Text key, Iterable<IntWritable> values, Reducer<Text, IntWritable, Text, NullWritable>.Context context) throws IOException, InterruptedException {
        int value = -1;
        int count = 0;
        for(IntWritable val : values) {
            count++;
            value = val.get();
        }
        assert count == 1;
        if(value > maxCount || (value == maxCount && key.toString().compareTo(maxUser) < 0)) {
            maxCount = value;
            maxUser = key.toString();
        }
    }

    @Override
    protected void cleanup(Reducer<Text, IntWritable, Text, NullWritable>.Context context) throws IOException, InterruptedException {
        if(maxUser != null)
            context.write(new Text(maxUser), NullWritable.get());
    }
}
